package uulm.teamname.marvelous.gamelibrary;

import java.util.Objects;

/** Represents a pair of two objects. */
public class Tuple<X, Y> {
    public final X item1;
    public final Y item2;

    /** Constructs a new {@link Tuple} based on the given objects. */
    public Tuple(X item1, Y item2) {
        this.item1 = item1;
        this.item2 = item2;
    }

    public static <X, Y> Tuple<X, Y> of(X x, Y y) {
        return new Tuple<X, Y>(x, y);
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        Tuple<?, ?> tuple = (Tuple<?, ?>) o;
        return Objects.equals(item1, tuple.item1) && Objects.equals(item2, tuple.item2);
    }

    @Override
    public int hashCode() {
        return Objects.hash(item1, item2);
    }

    @Override
    public String toString() {
        return "Tuple{" +
                "item1=" + item1 +
                ", item2=" + item2 +
                '}';
    }
}
