package uulm.teamname.marvelous.gamelibrary.config;

import jakarta.validation.constraints.NotEmpty;

import java.util.Arrays;
import java.util.Objects;

/**
 * POJO describing the ScenarioConfig as defined by the standard document
 */
public class ScenarioConfig {
    /** An array containing the map based on the {@link FieldType} enum. So, ROCK and GRASS basically. */
    @NotEmpty
    public FieldType[][] scenario;

    /** A string containing the name of the author of the scenario config */
    @NotEmpty
    public String author;

    /** A string containing the name of the scenario configuration (so basically the map title) */
    @NotEmpty
    public String name;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        ScenarioConfig that = (ScenarioConfig) o;
        return Arrays.deepEquals(scenario, that.scenario) && Objects.equals(author, that.author) && Objects.equals(name, that.name);
    }

    @Override
    public int hashCode() {
        int result = Objects.hash(author, name);
        result = 31 * result + Arrays.deepHashCode(scenario);
        return result;
    }

    @Override
    public String toString() {
        return "ScenarioConfig{" +
                "scenario=" + Arrays.deepToString(scenario) +
                ", author='" + author + '\'' +
                ", name='" + name + '\'' +
                '}';
    }
}
