package uulm.teamname.marvelous.gamelibrary.entities;

import java.util.HashMap;

/** Specifies the type of an {@link InfinityStone}. */
public enum StoneType {
    SpaceStone(0),
    MindStone(1),
    RealityStone(2),
    PowerStone(3),
    TimeStone(4),
    SoulStone(5);

    private final int id;
    private final static HashMap<Integer, StoneType> map = new HashMap<>();

    StoneType(int id) {
        this.id = id;
    }

    static {
        for (StoneType stoneType: StoneType.values()) {
            map.put(stoneType.id, stoneType);
        }
    }

    public static StoneType valueOf(int stoneType) {
        return map.get(stoneType);
    }

    public int getID() {
        return id;
    }
}
