package uulm.teamname.marvelous.gamelibrary.json.ingame;

import uulm.teamname.marvelous.gamelibrary.entities.EntityType;

import java.util.HashMap;
import java.util.Map;

public enum SerializedEntityType {
    NPC,
    Character,
    InfinityStone,
    Rock,
    Portal;

    private static final Map<EntityType, SerializedEntityType> entityTypeToDeserialized;

    static {
        entityTypeToDeserialized = new HashMap<>();

        entityTypeToDeserialized.put(EntityType.NPC, NPC);
        entityTypeToDeserialized.put(EntityType.P1, Character);
        entityTypeToDeserialized.put(EntityType.P2, Character);
        entityTypeToDeserialized.put(EntityType.InfinityStones, InfinityStone);
        entityTypeToDeserialized.put(EntityType.Rocks, Rock);
        entityTypeToDeserialized.put(EntityType.Portals, Portal);
    }

    public static SerializedEntityType valueOf(EntityType entityType) {
        return entityTypeToDeserialized.get(entityType);
    }
}
