package uulm.teamname.marvelous.gamelibrary.messages.client;

import uulm.teamname.marvelous.gamelibrary.messages.BasicMessage;
import uulm.teamname.marvelous.gamelibrary.messages.MessageType;

import jakarta.validation.constraints.NotNull;
import jakarta.validation.constraints.Size;
import java.util.Arrays;

public class CharacterSelectionMessage extends BasicMessage {

    /**
     * Boolean array that conveys information about what characters (6)
     * of the given characters (12) have been selected
     */
    @NotNull
    @Size(min = 12, max = 12, message = "doesn't have twelve elements")
    public Boolean[] characters;

    public CharacterSelectionMessage() {
        messageType = MessageType.CHARACTER_SELECTION;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        if (!super.equals(o)) return false;
        CharacterSelectionMessage that = (CharacterSelectionMessage) o;
        return Arrays.equals(characters, that.characters);
    }

    @Override
    public int hashCode() {
        int result = super.hashCode();
        result = 31 * result + Arrays.hashCode(characters);
        return result;
    }

    @Override
    public String toString() {
        return "CharacterSelectionMessage{" +
                "messageType=" + messageType +
                ", optionals='" + optionals + '\'' +
                ", characters=" + Arrays.toString(characters) +
                '}';
    }
}
