package uulm.teamname.marvelous.gamelibrary.messages.server;

import uulm.teamname.marvelous.gamelibrary.messages.BasicMessage;
import uulm.teamname.marvelous.gamelibrary.messages.MessageType;

import jakarta.validation.constraints.NotNull;
import java.util.Objects;

public class ConfirmSelectionMessage extends BasicMessage {

    /** Whether the other player is also done with the selection already */
    @NotNull
    public Boolean selectionComplete;

    public ConfirmSelectionMessage() {
        messageType = MessageType.CONFIRM_SELECTION;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        if (!super.equals(o)) return false;
        ConfirmSelectionMessage that = (ConfirmSelectionMessage) o;
        return Objects.equals(selectionComplete, that.selectionComplete);
    }

    @Override
    public int hashCode() {
        return Objects.hash(super.hashCode(), selectionComplete);
    }

    @Override
    public String toString() {
        return "ConfirmSelectionMessage{" +
                "messageType=" + messageType +
                ", optionals='" + optionals + '\'' +
                ", selectionComplete=" + selectionComplete +
                '}';
    }
}
