package uulm.teamname.marvelous.gamelibrary.messages.server;

import uulm.teamname.marvelous.gamelibrary.messages.BasicMessage;
import uulm.teamname.marvelous.gamelibrary.messages.MessageType;

import jakarta.validation.constraints.NotEmpty;
import jakarta.validation.constraints.NotNull;
import java.util.Objects;

public class GeneralAssignmentMessage extends BasicMessage {

    /** The ID of the game that the client is connected to. What this is used for is kind of unknown. */
    @NotNull
    @NotEmpty
    public String gameID;

    public GeneralAssignmentMessage() {
        messageType = MessageType.GENERAL_ASSIGNMENT;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        if (!super.equals(o)) return false;
        GeneralAssignmentMessage that = (GeneralAssignmentMessage) o;
        return Objects.equals(gameID, that.gameID);
    }

    @Override
    public int hashCode() {
        return Objects.hash(super.hashCode(), gameID);
    }

    @Override
    public String toString() {
        return "GeneralAssignmentMessage{" +
                "messageType=" + messageType +
                ", optionals='" + optionals + '\'' +
                ", gameID='" + gameID + '\'' +
                '}';
    }
}
