package uulm.teamname.marvelous.gamelibrary.requests;

import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import uulm.teamname.marvelous.gamelibrary.events.Event;
import uulm.teamname.marvelous.gamelibrary.events.EventType;
import uulm.teamname.marvelous.gamelibrary.json.ingame.deserialize.EventDeserializer;
import uulm.teamname.marvelous.gamelibrary.json.ingame.deserialize.RequestDeserializer;
import uulm.teamname.marvelous.gamelibrary.json.ingame.serialize.EventSerializer;
import uulm.teamname.marvelous.gamelibrary.json.ingame.serialize.RequestSerializer;

import java.util.HashMap;
import java.util.Map;
import java.util.Objects;

/** Represents a custom request */
@JsonDeserialize(using = RequestDeserializer.class)
@JsonSerialize(using = RequestSerializer.class)
public class CustomRequest extends Request {
    public String teamIdentifier;
    public Map<String, Object> customContent;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        if (!super.equals(o)) return false;
        CustomRequest that = (CustomRequest) o;
        return Objects.equals(teamIdentifier, that.teamIdentifier) && Objects.equals(customContent, that.customContent);
    }

    @Override
    public int hashCode() {
        return Objects.hash(super.hashCode(), teamIdentifier, customContent);
    }

    @Override
    public String toString() {
        return "CustomEvent{" +
                "eventType=" + this.type +
                ", teamIdentifier='" + teamIdentifier + '\'' +
                ", customContent=" + customContent +
                '}';
    }
}
